string name=defaultpolicy
int priority = 0xffffffff

strlist upperapps = "ksc-defender", "box-utils", "box-manager", "kysec2-scene", "kysec2-scene-example", policycoreutils, libchkuid, "kysec-utils", "kysec-daemon", "sm-enhancement", "sm-example", kmod, "kysec-sync-daemon", "kysec2-rbac-utils", "security-switch", "ksaf-label-manager", "policycoreutils", "libksaf-label-manager", "selinux-policy-common", "pam", "passwd", "adduser", "accountsservice", "kylin-ca-certificates"

# 1. policy 
strlist install_pkg = apt, dpkg, rpm, yum, dnf, "python3-dnf"
## 增加桌面升级相关组策略update_pkg
strlist update_pkg = "/usr/bin/ostree", "ostree-maintain-daemon", "/usr/share/kylin-system-updater/kylin-system-updater", "/usr/sbin/kylin-ostree-restore.py", "/usr/sbin/kylin-ostree-restore-plymouth.sh", "/etc/ostree/scripts/post-deploy/mm-upgrade", "/etc/ostree/scripts/post-deploy/ostree-xdiff", "/usr/share/initramfs-tools/scripts/init-bottom/system-layer", "/usr/bin/backup-daemon", "/usr/bin/systembackup-daemon", "dbus-daemon", "dbus-bin", "ostree", "ostree-maintain-daemon", "ostree-extra-utils", "ostree-coredata-protect", "kylin-system-updater", "yhkylin-backup-tools", "yhkylin-systembackup-tools", "kylin-os-manager", "kylin-os-manager-common"
strlist linkgroup = "/usr/lib/libksafpolicysync.so", "/usr/lib64/libksafpolicysync.so", "/usr/lib/libksafinterpreter.so.1", "/usr/lib/libksafinterpreter.so.1.0", "/usr/lib/libksafinterpreter.so.1.0.0", "/usr/lib64/libksafinterpreter.so.1", "/usr/lib64/libksafinterpreter.so.1.0", "/usr/lib64/libksafinterpreter.so.1.0.0"

strlist oidgroup = "libksaf-policy-sync", "ksaf-policy-interpreter", "ksaf-dynamic-uid"
strlist sidgroup = $oidgroup, $install_pkg, $update_pkg, $upperapps
strlist labelgroup = "ksaf-label-manager", "ksaf-label-manager-tools", "libksaf-label-manager", "libksaf-label-manager-devel"   

## 写权限保护
disallow * * $oidgroup file {write, truncate, exec, mkdir, rmdir, link, unlink, symlink, rename, setattr, setxattr, kmodinsert, interpret}
disallow * * $linkgroup file {write, truncate, exec, mkdir, rmdir, link, unlink, symlink, rename, setattr, setxattr, kmodinsert, interpret}
disallow * * "/etc/ksaf/*" file {write, truncate, exec, mkdir, rmdir, link, unlink, symlink, rename, setattr, setxattr, kmodinsert, interpret}
disallow * * "/etc/ksaf/*" dir {write, truncate, exec, mkdir, rmdir, link, unlink, symlink, rename, setattr, setxattr, kmodinsert, interpret}

## 读权限放行
allow * * $oidgroup file {open, read, getattr, getxattr, show}
allow * * $linkgroup file {open, read, getattr, getxattr, show}
allow * * "/etc/ksaf/*" file {open, read, getattr, getxattr, show}
allow * * "/etc/ksaf/*" dir {open, read, getattr, getxattr, show}

## 执行权限放行
allow root * $oidgroup file {exec, interpret}
allow root * $linkgroup file {exec, interpret}

## 特殊主体放行
allow * $sidgroup $oidgroup file {open, read, write, truncate, exec, mkdir, rmdir, link, unlink, symlink, rename, setattr, getattr, setxattr, getxattr, kmodinsert, show, interpret}
allow * $sidgroup $linkgroup file {open, read, write, truncate, exec, mkdir, rmdir, link, unlink, symlink, rename, setattr, getattr, setxattr, getxattr, kmodinsert, show, interpret}
allow * $sidgroup "/etc/ksaf/*" file {open, read, write, truncate, exec, mkdir, rmdir, link, unlink, symlink, rename, setattr, getattr, setxattr, getxattr, kmodinsert, show, interpret}
allow * $sidgroup "/etc/ksaf/*" dir {open, read, write, truncate, exec, mkdir, rmdir, link, unlink, symlink, rename, setattr, getattr, setxattr, getxattr, kmodinsert, show, interpret}

## 暂时对所有策略文件放开权限
## allow * * "/etc/ksaf/policy/*" file {open, read, write, truncate, exec, mkdir, rmdir, link, unlink, symlink, rename, setattr, getattr, setxattr, getxattr, kmodinsert, show, interpret}
## allow * * "/etc/ksaf/policy/*" dir {open, read, write, truncate, exec, mkdir, rmdir, link, unlink, symlink, rename, setattr, getattr, setxattr, getxattr, kmodinsert, show, interpret}

## 放行策略对标记管理的权限
allow * $oidgroup $labelgroup file {open, read, write, truncate, exec, mkdir, rmdir, link, unlink, symlink, rename, setattr, getattr, setxattr, getxattr, kmodinsert, show, interpret}

## 标记管理放行
## allow * $labelgroup * file {open, read, write, truncate, exec, mkdir, rmdir, link, unlink, symlink, rename, setattr, getattr, setxattr, getxattr, kmodinsert, show, interpret}
## allow * $labelgroup * dir {open, read, write, truncate, exec, mkdir, rmdir, link, unlink, symlink, rename, setattr, getattr, setxattr, getxattr, kmodinsert, show, interpret}
## allow * $labelgroup * lnkfile {open, read, write, truncate, exec, mkdir, rmdir, link, unlink, symlink, rename, setattr, getattr, setxattr, getxattr, kmodinsert, show, interpret}

## 只允许标记管理器修改ksaf标记
allow * $labelgroup * file {setksaf}
allow * $labelgroup * dir {setksaf}
allow * $labelgroup * lnkfile {setksaf}
disallow * * * file {setksaf}
disallow * * * file {setksaf}
disallow * * * file {setksaf}

# 2. ksaf_main.ko
disallow * * "/etc/ksaf/ksaf-main/class-def.conf" file {write, rename, unlink}
allow root $install_pkg "/etc/ksaf/ksaf-main/class-def.conf" file {write, rename, unlink}
allow * $update_pkg "/etc/ksaf/ksaf-main/class-def.conf" file {write, rename, unlink}
allow root "ksaf-main-module" "/etc/ksaf/ksaf-main/class-def.conf" file {write, rename, unlink}

disallow * * "/etc/ksaf/ksaf-main" dir {write, rename, unlink, rmdir}
allow root $install_pkg "/etc/ksaf/ksaf-main" dir {write, rename, unlink, rmdir}
allow * $update_pkg "/etc/ksaf/ksaf-main" dir {write, rename, unlink, rmdir}
allow root "ksaf-main-module" "/etc/ksaf/ksaf-main" dir {write, rename, unlink, rmdir}


# 3. kysec_exectl.ko
## 执行控制安裝文件列表
strlist kysec2_exectl_pkg = "libkysec2-exectl","kysec2-exectl-utils","libkysec2-exectl-wlist","kysec2-exectl-module"
strlist kysec2_exectl_bin_files = "/usr/sbin/kyexectl","/usr/sbin/kyexectl-init","/usr/sbin/kyexectl-verify"
strlist kysec2_sign_pkg = "libkylin-signtool", "certaide-kylin"

## 写执行控制配置文件或数据库的包列表
strlist write_kyexectl_conf_pkgs = "kysec2-exectl-utils", "kysec2-scene", "kysec-daemon", "kysec-utils", "kysec-sync-daemon", "kysec-auth", "ksaf-auth", "ksaf-label-manager", "ksaf-init", "ksc-defender", "sm-enhancement", "sm-example", kare, kaiming
## 读执行控制配置文件或数据库的包列表
strlist read_kyexectl_conf_pkgs = coreutils, peony, systemd, "libkytrusted-security", "ksc-defender"

## 只允许装包软件修改执行控制包列表文件
disallow * * $kysec2_exectl_pkg file {write,unlink}
allow * $install_pkg $kysec2_exectl_pkg file {write,unlink}
allow * $update_pkg $kysec2_exectl_pkg file {write,unlink}
allow * $upperapps $kysec2_exectl_pkg file {write,unlink}

## 允许执行控制程序有setxattr权限
allow * $kysec2_exectl_bin_files * file {setxattr}

## 不允许卸载执行控制模块
disallow * * kysec_exectl kmod {remove}
allow * $update_pkg kysec_exectl kmod {remove}

## 只允许指定程序访问执行控制配置文件或数据库
disallow * * "/etc/kyexectl/*" file {open, read, write, truncate, exec, mkdir, rmdir, link, unlink, symlink, rename, setattr, setxattr, kmodinsert, interpret}
disallow * * "/etc/kyexectl/*" dir {open, read, write, truncate, exec, mkdir, rmdir, link, unlink, symlink, rename, setattr, setxattr, kmodinsert, interpret}
allow * $read_kyexectl_conf_pkgs "/etc/kyexectl/*" file {open, read, getattr, getxattr, show}
allow * $read_kyexectl_conf_pkgs "/etc/kyexectl/*" dir {open, read, getattr, getxattr, show}
allow * $write_kyexectl_conf_pkgs "/etc/kyexectl/*" file {open, read, write, truncate, exec, mkdir, rmdir, link, unlink, symlink, rename, setattr, getattr, setxattr, getxattr, kmodinsert, show, interpret}
allow * $write_kyexectl_conf_pkgs "/etc/kyexectl/*" dir {open, read, write, truncate, exec, mkdir, rmdir, link, unlink, symlink, rename, setattr, getattr, setxattr, getxattr, kmodinsert, show, interpret}
allow * $install_pkg "/etc/kyexectl/*" file {open, read, write, truncate, mkdir, rmdir, link, unlink, symlink, rename, setattr, getattr, setxattr, getxattr, interpret}
allow * $install_pkg "/etc/kyexectl/*" dir {open, read, write, truncate, mkdir, rmdir, link, unlink, symlink, rename, setattr, getattr, setxattr, getxattr, interpret}
allow * $update_pkg "/etc/kyexectl/*" file {open, read, write, truncate, mkdir, rmdir, link, unlink, symlink, rename, setattr, getattr, setxattr, getxattr, interpret}
allow * $update_pkg "/etc/kyexectl/*" dir {open, read, write, truncate, mkdir, rmdir, link, unlink, symlink, rename, setattr, getattr, setxattr, getxattr, interpret}

disallow * * $kysec2_sign_pkg file {write, truncate, link, unlink, symlink, rmdir, rename, setattr, setxattr}
allow * $install_pkg $kysec2_sign_pkg file {write, truncate, link, unlink, symlink, rmdir, rename, setattr, setxattr}
allow * $update_pkg $kysec2_sign_pkg file {write, truncate, link, unlink, symlink, rmdir, rename, setattr, setxattr}

# 4. devctl
strlist devctl_linkgroup = "/usr/lib/libksaf_devctl.a", "/usr/lib64/libksaf_devctl.la", "/usr/lib64/libksaf_devctl.so", "/usr/lib64/libksaf_devctl.so.0", "/usr/lib64/libksaf_devctl.so.0.0.0"
strlist devctl_oidgroup = "ksaf-devctl", "ksaf-devctl-libs", "kysec2-devctl-module"
strlist devctl_sidgroup = "ksaf-devctl", "ksaf-devctl-libs", $install_pkg, $update_pkg, $upperapps

##  -- 暂时放开保护，等待三层策略就绪
disallow * * $devctl_oidgroup file {write,unlink,rename}
allow * $devctl_sidgroup $devctl_oidgroup file {write,unlink,rename}
allow * * $devctl_linkgroup file {open,exec,read,getattr,getxattr}
allow * $devctl_sidgroup "/sys/kernel/security/ksaf/status" file {open, read, getattr, getxattr}
disallow * * "/usr/sbin/ksaf-devctl-sync-daemon" process {kill}

# 5. init
strlist init_linkgroup = "/usr/lib64/libksaf_status.a", "/usr/lib64/libksaf_status.la", "/usr/lib64/libksaf_status.so", "/usr/lib64/libksaf_status.so.0", "/usr/lib64/libksaf_status.so.0.0.0", "/usr/lib/libksaf_status.a", "/usr/lib/libksaf_status.la", "/usr/lib/libksaf_status.so", "/usr/lib/libksaf_status.so.0", "/usr/lib/libksaf_status.so.0.0.0" 
strlist init_oidgroup = "ksaf-init"
strlist init_sidgroup = "ksaf-init", $install_pkg, $update_pkg, $upperapps

disallow * * $init_oidgroup file {write,unlink}
allow * $init_sidgroup $init_oidgroup file {write,unlink}
disallow * * $init_linkgroup file {write, truncate, exec, mkdir, rmdir, link, unlink, symlink, rename, setattr, setxattr, kmodinsert, interpret}
disallow * * $init_linkgroup lnkfile {write, truncate, exec, mkdir, rmdir, link, unlink, symlink, rename, setattr, setxattr, kmodinsert, interpret}
allow * * $init_linkgroup file {open, read, getattr, getxattr, show}
allow * * $init_linkgroup lnkfile {open, read, getattr, getxattr, show}
allow * $init_sidgroup $init_linkgroup file {open, read, write, truncate, exec, mkdir, rmdir, link, unlink, symlink, rename, setattr, getattr, setxattr, getxattr, kmodinsert, show, interpret}
allow * $init_sidgroup $init_linkgroup lnkfile {open, read, write, truncate, exec, mkdir, rmdir, link, unlink, symlink, rename, setattr, getattr, setxattr, getxattr, kmodinsert, show, interpret}
allow * $init_sidgroup "/etc/default/grub" file {open, read, write, getattr, getxattr, show}
allow * $init_sidgroup "/etc/ksaf/*" dir {open, read, write, truncate, exec, mkdir, rmdir, link, unlink, symlink, rename, setattr, getattr, setxattr, getxattr, kmodinsert, show, interpret}
allow * $init_sidgroup "/etc/ksaf/tmp/*" file {open, read, write, truncate, exec, mkdir, rmdir, link, unlink, symlink, rename, setattr, getattr, setxattr, getxattr, kmodinsert, show, interpret}
allow * $init_sidgroup "/etc/ksaf/mod_conf/*" file {open, read, write, truncate, exec, mkdir, rmdir, link, unlink, symlink, rename, setattr, getattr, setxattr, getxattr, kmodinsert, show, interpret}
allow * $init_sidgroup "/sys/kernel/security/ksaf/status" file {open, read, write, truncate, getattr, getxattr}

# 6. auth
strlist auth_oidgroup = "ksaf-auth"
strlist auth_sidgroup = "ksaf-auth", $install_pkg, $update_pkg, $upperapps
disallow * * $auth_oidgroup file {write,unlink,rename}
allow * $auth_sidgroup $auth_oidgroup file {write,unlink,rename}
allow * $auth_oidgroup "/etc/ksaf/*" dir {open, read, write, truncate, exec, mkdir, rmdir, link, unlink, symlink, rename, setattr, getattr, setxattr, getxattr, kmodinsert, show, interpret}
allow * * "/etc/ksaf/ksaf-auth/*" file {open, read, write, truncate, exec, mkdir, rmdir, link, unlink, symlink, rename, setattr, getattr, setxattr, getxattr, kmodinsert, show, interpret}


# 7. label
strlist LABEL_MANAGER = "/usr/sbin/ksaf-label-manager"
strlist LABEL_TOOL = "/usr/sbin/ksaf-label-manager-tool"

strlist LABEL_DATA = "/etc/ksaf/label/data/memory_data.json"
strlist LOG_CONF = "/etc/ksaf/label/ksaf-label-log.properties"
strlist DEV_CONF = "/etc/ksaf/label/ksaf-label-device-info.xml"
strlist INHERIT_CONF = "/etc/ksaf/label/ksaf-label-dir-inherit.conf"
strlist FILE_PKGID_CONF = "/etc/ksaf/label/ksaf-label-preallocated-file-pkgid.conf"
strlist FS_PKGID_CONF = "/etc/ksaf/label/ksaf-label-special-fs-pkgid.conf"
strlist TID_CONF = "/etc/ksaf/label/ksaf-label-interpreter-tid.conf"

strlist LABEL_LIB = "/usr/lib/libksaflabelmgr.so"
strlist LABEL_HEADER_FILE = "/usr/include/ksaf/ksaf_common.h", "/usr/include/ksaf/ksaf_labelmgr.h"

strlist SYS_ID_PAIRS = "/sys/kernel/security/ksaf/common/id_pairs"
strlist SYS_TMPFS = "/sys/kernel/security/ksaf/common/tmpfs"
strlist SYS_NOTIFY = "/sys/kernel/security/ksaf/common/id_pairs"

strlist CONFIG_FILE_GROUP = "/etc/ksaf/label/ksaf-label-device-info.xml", "/etc/ksaf/label/ksaf-label-dir-inherit.conf", "/etc/ksaf/label/ksaf-label-preallocated-file-pkgid.conf", "/etc/ksaf/label/ksaf-label-special-fs-pkgid.conf", "/etc/ksaf/label/ksaf-label-interpreter-tid.conf"


## 2501版本不支持临时文件系统打标
## allow * "/usr/sbin/ksaf-label-manager" "/sys/kernel/security/ksaf/common/id_pairs" file {write}
## allow * "/usr/sbin/ksaf-label-manager" "/sys/kernel/security/ksaf/common/tmpfs" file {write}
## disallow * * "/sys/kernel/security/ksaf/common/tmpfs" file {write}
## disallow * * "/sys/kernel/security/ksaf/common/id_pairs" file {write}
## disallow * * "/sys/kernel/security/ksaf/common/notify" file {read, write}
## allow * "/usr/sbin/ksaf-label-manager" "/sys/kernel/security/ksaf/common/notify" file {read, write}
## 除了标记管理程序其他程序都不能读取
disallow * * $LABEL_DATA file {open,read,write,truncate,rename,link,unlink,symlink,setattr,getattr,setxattr,getxattr}
allow   * $LABEL_MANAGER $LABEL_DATA file {open,read,write,truncate,link,unlink,symlink,rename,setattr,getattr,setxattr,getxattr}
allow   * $update_pkg $LABEL_DATA file {open,read,write,truncate,link,unlink,symlink,rename,setattr,getattr,setxattr,getxattr}

## 保护日志配置文件
disallow * * $LOG_CONF file {open,read,write,truncate,rename,link,unlink,symlink,setattr,getattr,setxattr,getxattr}
allow * $LABEL_MANAGER $LOG_CONF file {open,read,write,truncate,link,unlink,symlink,rename,setattr,getattr,setxattr,getxattr}
allow "root" * $LOG_CONF file {read, write, getattr}
allow * $install_pkg $LOG_CONF file {write,rename,unlink, getattr}
allow * $update_pkg $LOG_CONF file {open,read,write,truncate,rename,link,unlink,symlink,setattr,getattr,setxattr,getxattr}

## 保护所有其他配置文件
disallow * * $CONFIG_FILE_GROUP file {open,read,write,truncate,link,unlink,symlink,rename,setattr,getattr,setxattr,getxattr}
allow * $LABEL_MANAGER $CONFIG_FILE_GROUP file {open,read,write,truncate,link,unlink,symlink,rename,setattr,getattr,setxattr,getxattr}
## disallow root * $CONFIG_FILE_GROUP file {read, write, getattr}
allow * $install_pkg $CONFIG_FILE_GROUP file {write,rename,unlink, getattr}
allow * $update_pkg $CONFIG_FILE_GROUP file {open,read,write,truncate,link,unlink,symlink,rename,setattr,getattr,setxattr,getxattr}

## 标记管理服务程序对所有文件都可以设置扩展属性
allow * "/usr/sbin/ksaf-label-manager" * file {open, read, write, truncate, exec, mkdir, rmdir, link, unlink, symlink, rename, setattr, getattr, setxattr, getxattr, kmodinsert, show, interpret}
allow * "/usr/sbin/ksaf-label-manager" * dir {open, read, write, truncate, exec, mkdir, rmdir, link, unlink, symlink, rename, setattr, getattr, setxattr, getxattr, kmodinsert, show, interpret}
allow * "/usr/sbin/ksaf-label-manager" * lnkfile {open, read, write, truncate, exec, mkdir, rmdir, link, unlink, symlink, rename, setattr, getattr, setxattr, getxattr, kmodinsert, show, interpret}

## 标记管理软件包里面的文件不能被重命名和删除
disallow * * "ksaf-label-manager" file {write,rename,unlink}
allow * "ksaf-label-manager"  "ksaf-label-manager" file {write,rename,unlink}
allow * $install_pkg "ksaf-label-manager" file {write,rename,unlink}
allow * $update_pkg "ksaf-label-manager" file {write,rename,unlink}

## 进程防杀死
disallow * * $LABEL_MANAGER process {kill}
allow * $LABEL_MANAGER $LABEL_MANAGER process {kill}
allow * "/usr/bin/systemctl" $LABEL_MANAGER process {kill}
allow * "/usr/lib/systemd/systemd" $LABEL_MANAGER process {kill}
allow * $install_pkg $LABEL_MANAGER process {kill}
allow * $update_pkg $LABEL_MANAGER process {kill}

##只有root和secadm可以运行
disallow * * $LABEL_MANAGER file {exec}
allow root * $LABEL_MANAGER file {exec}
allow secadm * $LABEL_MANAGER file {exec} 

allow secadm "/usr/bin/systemctl" $LABEL_MANAGER file {exec} 
allow root "/usr/bin/systemctl" $LABEL_MANAGER file {exec}
allow secadm "/usr/bin/systemd/systemd" $LABEL_MANAGER file {exec}
allow root "/usr/bin/systemd/systemd" $LABEL_MANAGER file {exec}

## 标记运维工具只有root可以运行
disallow * * $LABEL_TOOL file {exec}
allow root * $LABEL_TOOL file {exec}

## 动态库文件和头文件保护
disallow * * $LABEL_LIB file {write,rename,unlink}
disallow * * $LABEL_HEADER_FILE file {write,rename,unlink}
allow * $install_pkg $LABEL_LIB file {write,rename,unlink, getattr}
allow * $install_pkg $LABEL_HEADER_FILE file {write,rename,unlink}
allow * $update_pkg $LABEL_LIB file {write,rename,unlink, getattr}
allow * $update_pkg $LABEL_HEADER_FILE file {write,rename,unlink, getattr}
allow * $upperapps $LABEL_LIB file {write,rename,unlink, getattr}
allow * $upperapps $LABEL_HEADER_FILE file {write,rename,unlink}

disallow * * "/etc/ksaf/label" dir {rmdir, link, unlink, symlink, rename}
allow * $update_pkg "/etc/ksaf/label" dir {rmdir, link, unlink, symlink, rename}

# 8. audit and rbac
## rbac原始配置文件只允许安装修改
strlist rbac_var1="/etc/kysec/rbac/auditadm.conf", "/etc/kysec/rbac/secadm.conf","/etc/kysec/rbac/root.conf","/usr/share/kysec-data/rbac/*"
disallow * * $rbac_var1 file {write,rename,unlink}
allow root $install_pkg $rbac_var1 file {write,rename,unlink}
allow * $update_pkg $rbac_var1 file {write,rename,unlink}

## rbac用户配置允许rbac程序和库修改,不支持"/etc/kysec/rbac/*-user.conf"只能用"/etc/kysec/rbac/*"替代
strlist rbac_var2="/usr/sbin/kysec-rbac-set","/usr/lib64/libkysec_rbac.a","/usr/lib64/libkysec_rbac.so.0.0.0","/usr/lib64/libkysec_rbac.so.0","/usr/lib64/libkysec_rbac.so"
disallow * * "/etc/kysec/rbac/*" file {write,rename,unlink}
allow * $rbac_var2 "/etc/kysec/rbac/*" file {write,rename,unlink}
allow * $update_pkg "/etc/kysec/rbac/*" file {write,rename,unlink}

## rbac相关命令不能被修改和删除
strlist rbac_var3="/usr/sbin/kysec-rbac-set", "/usr/sbin/kysec-rbac-query", "/usr/lib64/libkysec_rbac.a","/usr/lib64/libkysec_rbac.so.0.0.0","/usr/lib64/libkysec_rbac.so.0","/usr/lib64/libkysec_rbac.so"
disallow * * $rbac_var3 file {write,rename,unlink}
allow * $install_pkg $rbac_var3 file {write,rename,unlink}
allow * $update_pkg $rbac_var3 file {write,rename,unlink}

## audit日志只允许审计程序和日志清理文件修改，这里只对/var/log/ksaf_audit.log进行保护，没对/var/log/ksaf_audit.1.log ... /var/log/ksaf_audit.n.log保存，因不支持正则/var/log/ksaf_audit.*.log
strlist audit_var="/etc/logview/cleanlog.sh","/usr/sbin/ksaf-audit-daemon"
disallow * *  "/var/log/ksaf_audit.log" file {write,rename,unlink}
allow * $audit_var "/var/log/ksaf_audit.log" file {write,rename,unlink}
allow * $update_pkg "/var/log/ksaf_audit.log" file {write,rename,unlink}

## ksaf-audit-daemon命令不能被修改和删除
disallow * * "/usr/sbin/ksaf-audit-daemon" file {write,rename,unlink}
allow * $install_pkg "/usr/sbin/ksaf-audit-daemon" file {write,rename,unlink}
allow * $update_pkg "/usr/sbin/ksaf-audit-daemon" file {write,rename,unlink}

## integrity原始配置文件只允许安装修改
strlist integrity_var1="/etc/kysec/integrity/source/subject_integrity","/etc/kysec/integrity/source/object_integrity","/etc/kysec/integrity/source/package_integrity","/etc/kysec/integrity/source/user_integrity", "/usr/share/kysec-data/integrity/integrity.policy"

disallow * * $integrity_var1 file {write,rename,unlink}
allow root $install_pkg $integrity_var1 file {write,rename,unlink}
allow * $update_pkg $integrity_var1 file {write,rename,unlink}

## integrity用户配置文件只允许integrity程序和库修改
strlist integrity_var2="/etc/kysec/integrity/source/subject_integrity_user","/etc/kysec/integrity/source/object_integrity_user","/etc/kysec/integrity/source/package_integrity_user","/etc/kysec/integrity/source/user_integrity_user"
strlist integrity_var3="/usr/sbin/kysec-integrity-set","/usr/lib64/libkysec_integrity.a","/usr/lib64/libkysec_integrity.so.0","/usr/lib64/libkysec_integrity.so","/usr/lib64/libkysec_integrity.so.0.0.0"

disallow * * $integrity_var2 file {write,rename,unlink}
allow * $integrity_var3 $integrity_var2 file {write,rename,unlink}
allow * $update_pkg $integrity_var2 file {write,rename,unlink}

## integrity 中间配置文件只允许策略下发程序修改
strlist integrity_var4="/etc/kysec/integrity/data/subject_integrity","/etc/kysec/integrity/data/object_integrity","/etc/kysec/integrity/data/user_integrity","/etc/kysec/integrity/data/package_integrity"
strlist integrity_var5="/usr/sbin/kysec-ci-policy-issue","/usr/lib64/libkysec_ci_policy_issue.a","/usr/lib64/libkysec_ci_policy_issue.so","/usr/lib64/libkysec_ci_policy_issue.so.0","/usr/lib64/libkysec_ci_policy_issue.so.0.0.0"

disallow * * $integrity_var4 file {write,rename,unlink}
allow * $integrity_var5 $integrity_var4 file {write,rename,unlink}
allow * $update_pkg $integrity_var4 file {write,rename,unlink}

## integrity sys目录下策略文件只允许integrity程序和目录修改
strlist integrity_var6="/sys/kernel/security/kysec_integrity/policy_info","/sys/kernel/security/kysec_integrity/policy_map_clear"
disallow * * $integrity_var6 file {write,rename,unlink}
allow * $integrity_var5 $integrity_var6 file {write,rename,unlink}
allow * $update_pkg $integrity_var6 file {write,rename,unlink}

## confidentiality原始配置文件只允许安装修改
strlist confidentiality_var1="/etc/kysec/confidentiality/source/subject_confidentiality","/etc/kysec/confidentiality/source/object_confidentiality","/etc/kysec/confidentiality/source/package_confidentiality","/etc/kysec/confidentiality/source/user_confidentiality", "/usr/share/kysec-data/confidentiality/confidentiality.policy"

disallow * * $confidentiality_var1 file {write,rename,unlink}
allow root $install_pkg $confidentiality_var1 file {write,rename,unlink}
allow * $update_pkg $confidentiality_var1 file {write,rename,unlink}

## confidentiality用户配置文件只允许confidentiality程序和库修改
strlist confidentiality_var2="/etc/kysec/confidentiality/source/subject_confidentiality_user","/etc/kysec/confidentiality/source/object_confidentiality_user","/etc/kysec/confidentiality/source/package_confidentiality_user","/etc/kysec/confidentiality/source/user_confidentiality_user"
strlist confidentiality_var3="/usr/sbin/kysec-confidentiality-set","/usr/lib64/libkysec_confidentiality.a","/usr/lib64/libkysec_confidentiality.so.0","/usr/lib64/libkysec_confidentiality.so","/usr/lib64/libkysec_confidentiality.so.0.0.0"

disallow * * $confidentiality_var2 file {write,rename,unlink}
allow * $confidentiality_var3 $confidentiality_var2 file {write,rename,unlink}
allow * $update_pkg $confidentiality_var2 file {write,rename,unlink}

## confidentiality 中间配置文件只允许策略下发程序修改
strlist confidentiality_var4="/etc/kysec/confidentiality/data/subject_confidentiality","/etc/kysec/confidentiality/data/object_confidentiality","/etc/kysec/confidentiality/data/user_confidentiality","/etc/kysec/confidentiality/data/package_confidentiality"
strlist confidentiality_var5="/usr/sbin/kysec-ci-policy-issue","/usr/lib64/libkysec_ci_policy_issue.a","/usr/lib64/libkysec_ci_policy_issue.so","/usr/lib64/libkysec_ci_policy_issue.so.0","/usr/lib64/libkysec_ci_policy_issue.so.0.0.0"

disallow * * $confidentiality_var4 file {write,rename,unlink}
allow * $confidentiality_var5 $confidentiality_var4 file {write,rename,unlink}
allow * $update_pkg $confidentiality_var4 file {write,rename,unlink}

## confidentiality sys目录下策略文件只允许confidentiality程序和目录修改
strlist confidentiality_var6="/sys/kernel/security/kysec_confidentiality/policy_info","/sys/kernel/security/kysec_confidentiality/policy_map_clear"
disallow * * $confidentiality_var6 file {write,rename,unlink}
allow * $confidentiality_var5 $confidentiality_var6 file {write,rename,unlink}
allow * $update_pkg $confidentiality_var6 file {write,rename,unlink}

